#include <WindowsConstants.au3>
#include <GUIConstantsEx.au3>
#include <File.au3>
#include <Array.au3>
#include <GuiRichEdit.au3>
#include <WinAPI.au3>
#include <GuiTab.au3>
#include <IE.au3>
#include <GuiListView.au3>
Opt("GUIOnEventMode",1)

Global $iWidth=1920,$iHeight=1080,$iLastTab=-1,$iLastFunctionIndex=-1,$iFontSize=12,$sFontFamily="Courier monospace"
Global $sSettingsFile="settings.ini",$sFolderExtracted=@ScriptDir&"\extracted",$sResultFolder=@ScriptDir&"\ready",$sResultFolderZIP=@ScriptDir&"\readyZIP"
Global $iLastGui=-1,$iGUIEDITGUI=0,$iGUISELFUNC=1
Global $arContainerTypes=[".rar",".zip"]
Global $hGui,$arTabs[0][2],$hMainTab,$arFunctionList,$hListViewFunction,$doAutoCompare=true,$doLoadGermanFile=true
Global $oIE,$arLastShowPacket[2]
Global $css="table {border-collapse: collapse;margin-top: 10px;width:100%;font-size:"&$iFontSize&"px;font-family: 'Bitstream Vera Sans Mono', Courier, monospace;border: 1px solid #CCC;}"& _
			"td {padding: 1px 2px;white-space: pre;}"& _
			"td.bredecode {width: 100%;padding-left: 4px;}"& _
			"td.codekolom {text-align: right;min-width: 3em;background-color: #ECECEC;border-right: 1px solid #DDD;color: #AAA;}"& _
			"tr.add {background: #DFD;}"& _
			"tr.del {background: #FDD;}"

$oIE=_IECreate("http://www.quickdiff.com/",0,0,0,0)

GUIRegisterMsg($WM_SIZE, '_resize')
GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")


$hGui=GUICreate("AutoIt-Help Translate",$iWidth,$iHeight,-1,-1,BitOR($WS_MINIMIZEBOX,$WS_CAPTION,$WS_POPUP,$WS_SYSMENU,$WS_SIZEBOX,$WS_MAXIMIZEBOX))
$cInputPacketFolder=GUICtrlCreateInput(@ScriptDir,0,0,1,1)
GUICtrlSetState(-1,$GUI_HIDE)
$cButtonPacketFolder=GUICtrlCreateButton("...",0,0,1,1)
GUICtrlSetState(-1,$GUI_HIDE)
GUICtrlSetOnEvent(-1,"_selectFolder")
$cButtonPacketSearch=GUICtrlCreateButton("FIND",0,0,1,1)
GUICtrlSetState(-1,$GUI_HIDE)
GUICtrlSetOnEvent(-1,"_findPackets")
$hListViewPacket=GUICtrlCreateListView("Path|Functions",0,0,1,1)
GUICtrlSetState(-1,$GUI_HIDE)
_GUICtrlListView_SetColumnWidth($hListViewPacket,0,0)
_GUICtrlListView_SetColumnWidth($hListViewPacket,1,$LVSCW_AUTOSIZE_USEHEADER)
$cButtonZIPFile=GUICtrlCreateButton("ZIP-Packet",0,0,1,1)
GUICtrlSetState(-1,$GUI_HIDE)
GUICtrlSetOnEvent(-1,"_zipFile")
$hListViewFunction=GUICtrlCreateListView("Function",0,0,1,1)
GUICtrlSetState(-1,$GUI_HIDE)
_GUICtrlListView_SetColumnWidth($hListViewFunction,0,$LVSCW_AUTOSIZE_USEHEADER)
$hRichEditMainFile=_GUICtrlRichEdit_Create($hGui,"",0,0,1,1,BitOR($WS_HSCROLL,$WS_VSCROLL,$ES_AUTOVSCROLL,$ES_MULTILINE))
_RichEdit_changeFont($hRichEditMainFile,$iFontSize,$sFontFamily)
ControlHide($hGui,"",$hRichEditMainFile)
$cButtonSaveFile=GUICtrlCreateButton("SAVE",0,0,1,1)
GUICtrlSetState(-1,$GUI_HIDE)
GUICtrlSetOnEvent(-1,"_saveFile")
$cButtonSaveCloseFile=GUICtrlCreateButton("SAVE and BACK",0,0,1,1)
GUICtrlSetState(-1,$GUI_HIDE)
GUICtrlSetOnEvent(-1,"_saveFileClose")
$hMainTab=GUICtrlCreateTab(0,0,0,0)
ControlHide($hGui,"",$hMainTab)

$cTab = GUICtrlCreateDummy()
GUICtrlSetOnEvent($cTab,"_pressTab")
Local $aAccelKeys[1][2] = [["{TAB}", $cTab]]
GUISetAccelerators($aAccelKeys)

GUISetOnEvent(-3,"_close",$hGui)
GUISetState(@SW_SHOW)
_resize()

_loadSettings()

_switchGui($iGUISELFUNC)
_findPackets()

While sleep(10)
WEnd

Func _pressTab()
	$cFocus=ControlGetFocus($hGui)
	ControlSend($hGui,"",$cFocus,"^{TAB}")
EndFunc

Func _loadSettings()
	$doAutoCompare=false
	If IniRead($sSettingsFile,"general","autoCompare","true")="true" Then $doAutoCompare=true
	$doLoadGermanFile=false
	If IniRead($sSettingsFile,"general","loadGermanFile","true")="true" Then $doLoadGermanFile=true
	$sFolderExtracted=IniRead($sSettingsFile,"general","extractFolder",$sFolderExtracted)
	$sResultFolder=IniRead($sSettingsFile,"general","readyFolder",$sResultFolder)
	$sResultFolderZIP=IniRead($sSettingsFile,"general","resultFolder",$sResultFolderZIP)
	GUICtrlSetData($cInputPacketFolder,IniRead($sSettingsFile,"general","packetFolder",@ScriptDir))
	$arPos=WinGetPos($hGui)
	WinMove($hGui,"",IniRead($sSettingsFile,"general","X",$arPos[0]),IniRead($sSettingsFile,"general","Y",$arPos[1]), _
					 IniRead($sSettingsFile,"general","W",$arPos[2]),IniRead($sSettingsFile,"general","H",$arPos[3]))
	If IniRead($sSettingsFile,"general","iState","true")="true" Then GUISetState(@SW_MAXIMIZE,$hGui)
EndFunc

Func _zipFile()
	$index=_GUICtrlListView_GetSelectedIndices($hListViewPacket,false)
	ConsoleWrite("INDEX:"&$index&@crlf)
	If $index<>-1 Then
		$sFolder=_GUICtrlListView_GetItemText($hListViewPacket,int($index),1)
		_zip($sResultFolder&"\"&$sFolder,$sResultFolderZIP&"\"&$sFolder&".zip")
	EndIf
	_refreshTablesSelGui()
EndFunc

Func _zip($sFolder,$sZipFile)
	$pid=Run("7z.exe a -tzip """&$sZipFile&""" """&$sFolder&"\*.txt""",@ScriptDir,@SW_HIDE,BitOR(2,4))
	ProcessWaitClose($pid)
	$sOut=StderrRead($pid)
	If StringInStr($sOut,"ERROR") Then
		MsgBox(16,"Error","Cannot ZIP-Files: "&@crlf&@crlf&$sOut)
		return SetError(1,0,false)
	EndIf
	return true
EndFunc

Func _saveFileClose()
	_saveFile()
	_switchGui($iGUISELFUNC)
	_refreshTablesSelGui()
EndFunc

Func _saveFile()
	$sText=_GUICtrlRichEdit_GetText($hRichEditMainFile)
	If NOT FileExists($sResultFolder&"\"&$arLastShowPacket[1]) Then DirCreate($sResultFolder&"\"&$arLastShowPacket[1])
	FileWrite($sResultFolder&"\"&$arLastShowPacket[1]&"\"&$arFunctionList[$iLastFunctionIndex][0]&".txt",$sText)
	If @error Then MsgBox(16,"Error","File could not be saved: "&@error)
EndFunc

Func _refreshTablesSelGui()
	_showPacketFunctions()
	_findPackets()
EndFunc

Func _showPacketFunctions($sFile=$arLastShowPacket[0],$sFunctions=$arLastShowPacket[1])
	$arLastShowPacket[0]=$sFile
	$arLastShowPacket[1]=$sFunctions
	_GUICtrlListView_DeleteAllItems($hListViewFunction)
	$sFolder=$sFolderExtracted&"\"&$sFunctions
	If NOT FileExists($sFolder) Then
		If NOT _extract($sFile,$sFolder) Then return SetError(1,0,false)
	EndIf
	local $arFunctions=_getFunctionFiles($sFolder)
	$arFunctionList=$arFunctions
	for $i=0 to UBound($arFunctions)-1 step 1
		$hItem=GUICtrlCreateListViewItem($arFunctions[$i][0],$hListViewFunction)
		If FileExists($sResultFolder&"\"&$sFunctions&"\"&$arFunctions[$i][0]&".txt") Then GUICtrlSetBkColor($hItem,0x00FF00)
	next
EndFunc

Func _extract($sFile,$sFolder)
	$pid=Run("7z.exe e """&$sFile&""" -o"""&$sFolder&"""",@ScriptDir,@SW_HIDE,BitOR(2,4))
	ProcessWaitClose($pid)
	$sOut=StderrRead($pid)
	If StringInStr($sOut,"ERROR") Then
		MsgBox(16,"Error","Cannot Extract Archive: "&@crlf&@crlf&$sOut)
		return SetError(1,0,false)
	EndIf
	return true
EndFunc

Func _selectFolder()
	$sFolder=FileSelectFolder("Choose Folder",FileExists(GUICtrlRead($cInputPacketFolder))?GUICtrlRead($cInputPacketFolder):@ScriptDir,0,"",$hGui)
	If NOT @error Then GUICtrlSetData($cInputPacketFolder,$sFolder)
EndFunc

Func _findPackets()
	_GUICtrlListView_DeleteAllItems($hListViewPacket)
	$sFolder=GUICtrlRead($cInputPacketFolder)
	If FileExists($sFolder) Then
		$arPackets=_getPackedFiles($sFolder)
		for $i=0 to UBound($arPackets)-1 step 1
			$hItem=GUICtrlCreateListViewItem($arPackets[$i][0]&"|"&$arPackets[$i][1],$hListViewPacket)
			If FileExists($sResultFolder&"\"&$arPackets[$i][1]) Then GUICtrlSetBkColor($hItem,0xFFFF00)
			If FileExists($sResultFolderZIP&"\"&$arPackets[$i][1]&".zip") Then GUICtrlSetBkColor($hItem,0x00FF00)
		next
	EndIf
EndFunc

Func _switchGui($iGui)
	Switch $iLastGui
		Case $iGUIEDITGUI
			ControlHide($hGui,"",$hRichEditMainFile)
			ControlHide($hGui,"",$hMainTab)
			GUICtrlSetState($cButtonSaveFile,$GUI_HIDE)
			GUICtrlSetState($cButtonSaveCloseFile,$GUI_HIDE)
			If $iLastTab<>-1 Then _hideTab($arTabs,$iLastTab)
		Case $iGUISELFUNC
			GUICtrlSetState($cInputPacketFolder,$GUI_HIDE)
			GUICtrlSetState($cButtonPacketFolder,$GUI_HIDE)
			GUICtrlSetState($cButtonPacketSearch,$GUI_HIDE)
			GUICtrlSetState($hListViewPacket,$GUI_HIDE)
			GUICtrlSetState($hListViewFunction,$GUI_HIDE)
			GUICtrlSetState($cButtonZIPFile,$GUI_HIDE)
	EndSwitch
	$iLastGui=$iGui
	Switch $iGui
		case $iGUIEDITGUI
			ControlShow($hGui,"",$hRichEditMainFile)
			ControlShow($hGui,"",$hMainTab)
			GUICtrlSetState($cButtonSaveFile,$GUI_SHOW)
			GUICtrlSetState($cButtonSaveCloseFile,$GUI_SHOW)
			If $iLastTab<>-1 Then _showTab($arTabs,$iLastTab)
		case $iGUISELFUNC
			GUICtrlSetState($cInputPacketFolder,$GUI_SHOW)
			GUICtrlSetState($cButtonPacketFolder,$GUI_SHOW)
			GUICtrlSetState($cButtonPacketSearch,$GUI_SHOW)
			GUICtrlSetState($hListViewPacket,$GUI_SHOW)
			GUICtrlSetState($hListViewFunction,$GUI_SHOW)
			GUICtrlSetState($cButtonZIPFile,$GUI_SHOW)
	EndSwitch
EndFunc

Func _getDiff($oIEInline,$sFileOne,$sFileTwo)
	_IENavigate($oIEInline, "about:blank")
	$iPoints=0
	_IEErrorNotify(false)
	While NOT _IELoadWait($oIE,0,1000)
		$sPoints=""
		for $i=0 to $iPoints step 1
			$sPoints&="."
		next
		_IEDocWriteHTML($oIEInline,"<html><head></head><body>Loading "&$sPoints&"</body></html>")
		$iPoints+=1
		If $iPoints>2 Then $iPoints=0
	WEnd
	_IEErrorNotify(True)
	$oForm=_IEFormGetObjByName($oIE,"diffForm")
	$oLeft=_IEFormElementGetObjByName($oForm,"een")
	$oRight=_IEFormElementGetObjByName($oForm,"twee")
	_IEFormElementSetValue($oLeft,$sFileOne,1)
	_IEFormElementSetValue($oRight,$sFileTwo,1)
	$oSubmit=-1
	for $oObj In _IEFormElementGetCollection($oForm)
		If _IEFormElementGetValue($oObj)="Compare" Then
			$oSubmit=$oObj
		EndIf
	next
	If $oSubmit<>-1 Then
		_IEAction($oSubmit,"click")
		$oTable=_IEGetObjById($oIE,"res")
		_IEDocWriteHTML($oIEInline,"<html><head><style>"&$css&"</style></head><body><table>"&$oTable.innerHTML&"</table></body></html>")
	EndIf
EndFunc

Func _RichEdit_changeFont($hRichEdit, $iSize, $sFamily)
    _GUICtrlRichEdit_SetSel($hRichEdit, 0, -1, True) ; select all
    _GUICtrlRichEdit_SetFont($hRichEdit, $iSize)
    _GUICtrlRichEdit_Deselect($hRichEdit) ; deselect all
EndFunc   ;==>ChangeFontSize

Func _loadFunction( ByRef $arFunctions,$index)
	$iLastFunctionIndex=$index
	$sFunction=$arFunctions[$index][0]
	_clearTabs()
	ReDim $arTabs[UBound($arFunctions,2)-1][2]
	local $iCount=0
	for $i=2 to UBound($arFunctions,2)-1 step 1
		If $arFunctions[$index][$i]<>"" Then
			$arTabs[$iCount][0]=GUICtrlCreateTabItem($arFunctions[$index][$i])
			local $arControls[1][2]
			$arControls[0][0]="RICHEDIT"
			$arControls[0][1]=_GUICtrlRichEdit_Create($hGui,FileRead($arFunctions[$index][1]&"\"&$arFunctions[$index][$i]),0,0,1,1,BitOR($WS_HSCROLL,$WS_VSCROLL,$ES_AUTOVSCROLL,$ES_MULTILINE))
			_RichEdit_changeFont($arControls[0][1],$iFontSize,$sFontFamily)
			ControlHide($hGui,"",$arControls[0][1])
			$arTabs[$iCount][1]=$arControls
			$iCount+=1
		EndIf
	next
	ReDim $arTabs[$iCount][2]
	GUICtrlCreateTabItem("")
	$iLastTab=UBound($arTabs)-1
	_showTab($arTabs,$iLastTab)
	_resize()
	If FileExists($sResultFolder&"\"&$arLastShowPacket[1]&"\"&$arFunctions[$index][0]&".txt") Then
		_GUICtrlRichEdit_SetText($hRichEditMainFile,FileRead($sResultFolder&"\"&$arLastShowPacket[1]&"\"&$arFunctions[$index][0]&".txt"))
		_RichEdit_changeFont($hRichEditMainFile,$iFontSize,$sFontFamily)
	ElseIf $arFunctions[$index][UBound($arFunctions,2)-1]<>"" and $doLoadGermanFile Then
		_GUICtrlRichEdit_SetText($hRichEditMainFile,FileRead($arFunctions[$index][1]&"\"&$arFunctions[$index][UBound($arFunctions,2)-1]))
		_RichEdit_changeFont($hRichEditMainFile,$iFontSize,$sFontFamily)
	Else
		_GUICtrlRichEdit_SetText($hRichEditMainFile,"")
		_RichEdit_changeFont($hRichEditMainFile,$iFontSize,$sFontFamily)
	EndIf
	If $arFunctions[$index][2]<>"" and $arFunctions[$index][3]<>"" and $doAutoCompare Then _diff($arFunctions)
EndFunc

Func _diff($arFunctions)
	ReDim $arTabs[UBound($arTabs)+1][2]
	local $index=UBound($arTabs)-1
	$arTabs[$index][0]=GUICtrlCreateTabItem("Compare")
	local $arControls[2][2]
	$arControls[1][0]="IEEMB"
	$arControls[1][1]=_IECreateEmbedded()
	$arControls[0][0]="IEOBJ"
	$arControls[0][1]=GUICtrlCreateObj($arControls[1][1],5,5,5,5)
	GUICtrlSetState($arControls[0][1],$GUI_HIDE)
	$arTabs[$index][1]=$arControls
	_resize()
	_hideTab($arTabs,$iLastTab)
	_showTab($arTabs,$index)
	_getDiff($arControls[1][1],FileRead($arFunctions[$iLastFunctionIndex][1]&"\"&$arFunctions[$iLastFunctionIndex][2]), _
							   FileRead($arFunctions[$iLastFunctionIndex][1]&"\"&$arFunctions[$iLastFunctionIndex][3]))
EndFunc

Func _hideTab(Byref $arTabs,$index)
	If $iLastGui=$iGUIEDITGUI Then
		$arControls=$arTabs[$index][1]
		for $i=0 to UBound($arControls)-1 step 1
			If $arControls[$i][0]="RICHEDIT" Then ControlHide($hGui,"",$arControls[$i][1])
			If $arControls[$i][0]="IEOBJ" Then GUICtrlSetState($arControls[0][1],$GUI_HIDE)
		next
	EndIf
	$iLastTab=-1
EndFunc

Func _showTab(Byref $arTabs,$index)
	$iLastTab=$index
	If $iLastGui=$iGUIEDITGUI Then
		$arControls=$arTabs[$index][1]
		for $i=0 to UBound($arControls)-1 step 1
			If $arControls[$i][0]="RICHEDIT" Then ControlShow($hGui,"",$arControls[$i][1])
			If $arControls[$i][0]="IEOBJ" Then GUICtrlSetState($arControls[0][1],$GUI_SHOW)
		next
		_GUICtrlTab_ActivateTab($hMainTab,$index)
	EndIf
EndFunc

Func _clearTabs()
	for $i=0 to UBound($arTabs)-1 step 1
		$arControls=$arTabs[$i][1]
		for $j=0 to UBound($arControls)-1 step 1
			Switch $arControls[$j][0]
				case "RICHEDIT"
					_GUICtrlRichEdit_Destroy($arControls[$j][1])
				case "IEOBJ"
					GUICtrlDelete($arControls[$j][1])
			EndSwitch
		next
		GUICtrlDelete($arTabs[$i][0])
	next
	$iLastTab=-1
	ReDim $arTabs[0][2]
EndFunc

Func _resize($hwnd=$hGui, $iMsg=-1, $iwParam=-1, $ilParam=-1)
	If $hwnd=$hGui Then
		$iWidth=WinGetPos($hGui)[2]
		$iHeight=WinGetPos($hGui)[3]
		$tRECT=_WinAPI_GetClientRect($hwnd)
		local $iAreaWidth=DllStructGetData($tRECT, "Right"),$iAreaHeight=DllStructGetData($tRECT, "Bottom")
		;StartGui
		GUICtrlSetPos($cInputPacketFolder,5,5,$iAreaWidth-10-95,25)
		GUICtrlSetPos($cButtonPacketFolder,$iAreaWidth-90,5,25,25)
		GUICtrlSetPos($cButtonPacketSearch,$iAreaWidth-60,5,55,25)
		GUICtrlSetPos($hListViewPacket,5,35,($iAreaWidth-15)/2,$iAreaHeight-10-35-40)
		_GUICtrlListView_SetColumnWidth($hListViewPacket,1,$LVSCW_AUTOSIZE_USEHEADER)
		GUICtrlSetPos($cButtonZIPFile,5,35+$iAreaHeight-10-35-40+5,($iAreaWidth-15)/2,25)
		GUICtrlSetPos($hListViewFunction,5+($iAreaWidth-15)/2+5,35,($iAreaWidth-15)/2,$iAreaHeight-10-35)
		_GUICtrlListView_SetColumnWidth($hListViewFunction,0,$LVSCW_AUTOSIZE_USEHEADER)
		;EditGui
		ControlMove($hGui,"",$hRichEditMainFile,5+5+($iAreaWidth-15)/2,5,($iAreaWidth-15)/2,$iAreaHeight-10-40)
		GUICtrlSetPos($hMainTab,5,5,($iAreaWidth-15)/2,$iAreaHeight-10)
		GUICtrlSetPos($cButtonSaveFile,5+5+($iAreaWidth-15)/2,$iAreaHeight-10-40+10,(($iAreaWidth-15)/2-5)/2,25)
		GUICtrlSetPos($cButtonSaveCloseFile,5+5+($iAreaWidth-15)/2+(($iAreaWidth-15)/2-5)/2+5,$iAreaHeight-10-40+10,(($iAreaWidth-15)/2-5)/2,25)
		for $i=0 to UBound($arTabs)-1 step 1
			$arControls=$arTabs[$i][1]
			$arTabSize=ControlGetPos($hGui,"",$hMainTab)
			local $iLeft=0,$iTop=25,$iTabWidth=$arTabSize[2]-10,$iTabHeight=$arTabSize[3]-25
			for $j=0 to UBound($arControls)-1 step 1
				If $arControls[$j][0]="RICHEDIT" Then ControlMove($hGui,"",$arControls[$j][1],$iLeft+10,$iTop+5,$iTabWidth-5,$iTabHeight-10)
				If $arControls[$j][0]="IEOBJ" Then GUICtrlSetPos($arControls[$j][1],$iLeft+10,$iTop+5,$iTabWidth-5,$iTabHeight-10)
			next
		next
	EndIf
	Return 'GUI_RUNDEFMSG'
EndFunc

Func _getFunctionFiles($sFolder)
	local $arFiles=_FileListToArray($sFolder,"*.txt",$FLTA_FILES,false)
	local $arFunctions[UBound($arFiles)][5],$iCount=-1
	$lastFile=""
	for $i=1 to UBound($arFiles)-1 step 1
		$arResult=StringRegExp($arFiles[$i],"(.*?) (.*?).txt",2)
		If $arResult[1]<>$lastFile Then
			$iCount+=1
			$lastFile=$arResult[1]
			$arFunctions[$iCount][0]=$arResult[1]
			$arFunctions[$iCount][1]=$sFolder
		EndIf
		If $arResult[2]="deutsch" Then
			$arFunctions[$iCount][4]=$arFiles[$i]
		Else
			for $j=2 to UBound($arFunctions,2)-2 step 1
				If $arFunctions[$iCount][$j]="" Then
					$arFunctions[$iCount][$j]=$arFiles[$i]
					ExitLoop
				EndIf
				$arSplitIst=StringSplit(StringRegExp($arFunctions[$iCount][$j],"(.*?) (.*?).txt",2)[2],"_",BitOR(1,2))
				$arSplitSoll=StringSplit($arResult[2],"_",BitOR(1,2))
				for $k=0 to UBound($arSplitIst)-1 step 1
					If $k>UBound($arSplitSoll)-1 Then ExitLoop
					If Int($arSplitIst[$k])>Int($arSplitSoll[$k]) Then
						If $j<UBound($arFunctions,2)-2 Then
							$arFunctions[$iCount][$j+1]=$arFunctions[$iCount][$j]
						EndIf
						$arFunctions[$iCount][$j]=$arFiles[$i]
						ExitLoop 2
					EndIf
				next
			next
		EndIf
	next
	ReDim $arFunctions[$iCount+1][5]
	return $arFunctions
EndFunc

Func _getPackedFiles($sFolder)
	local $arFiles=_FileListToArray($sFolder,"*",$FLTA_FILES,true)
	local $arResult[UBound($arFiles)][2],$iCount=0
	If UBound($arContainerTypes)<1 Then _error("There must be at least one ContainerType defined!",true)
	local $sTypes="("&StringReplace($arContainerTypes[0],".","\.")
	for $i=1 to UBound($arContainerTypes)-1 step 1
		$sTypes&="|"&StringReplace($arContainerTypes[$i],".","\.")
	next
	$sTypes&=")"
	for $i=0 to UBound($arFiles)-1 step 1
		If StringRegExp($arFiles[$i],"(.*?)"&$sTypes) Then
			$arResult[$iCount][0]=$arFiles[$i]
			$arResult[$iCount][1]=StringRegExp($arFiles[$i],"(?:.*)\\(.*?)(?: txt)?\.(?:.*?)",2)[1]
			$iCount+=1
		EndIf
	next
	ReDim $arResult[$iCount][2]
	return $arResult
EndFunc

Func _error($msg,$exit=false)
	MsgBox(16,"Error",$msg)
	If $exit Then _close()
EndFunc

Func _close()
	$arPos=WinGetPos($hGui)
	$sFolder=GUICtrlRead($cInputPacketFolder)
	IniWrite($sSettingsFile,"general","extractFolder",$sFolderExtracted)
	IniWrite($sSettingsFile,"general","readyFolder",$sResultFolder)
	IniWrite($sSettingsFile,"general","resultFolder",$sResultFolderZIP)
	IniWrite($sSettingsFile,"general","X",$arPos[0])
	IniWrite($sSettingsFile,"general","Y",$arPos[1])
	IniWrite($sSettingsFile,"general","W",$arPos[2])
	IniWrite($sSettingsFile,"general","H",$arPos[3])
	IniWrite($sSettingsFile,"general","packetFolder",$sFolder)
	IniWrite($sSettingsFile,"general","iState",(BitAND(WinGetState($hGui),32)=32)?"true":"false")
	IniWrite($sSettingsFile,"general","autoCompare",$doAutoCompare)
	IniWrite($sSettingsFile,"general","loadGermanFile",$doLoadGermanFile)
	_IEQuit($oIE)
	_clearTabs()
	_GUICtrlRichEdit_Destroy($hRichEditMainFile)
	exit
EndFunc

Func WM_NOTIFY($hWnd, $iMsg, $iwParam, $ilParam)
    #forceref $hWnd, $iMsg, $iwParam
    Local $hWndFrom, $iIDFrom, $iCode, $tNMHDR, $hWndTab, $iTab
    $tNMHDR = DllStructCreate($tagNMHDR, $ilParam)
    $hWndFrom = HWnd(DllStructGetData($tNMHDR, "hWndFrom"))
    $iIDFrom = DllStructGetData($tNMHDR, "IDFrom")
    $iCode = DllStructGetData($tNMHDR, "Code")
    Switch $hWndFrom
		Case ControlGetHandle($hGui,"",$hMainTab)
            Switch $iCode
				Case $TCN_SELCHANGE
                    $iTab = _GUICtrlTab_GetCurSel($hMainTab)
					If $iLastTab<>-1 and $iTab<>$iLastTab Then
						_hideTab($arTabs,$iLastTab)
					EndIf
					If $iTab>-1 and $iTab<UBound($arTabs) and $iTab<>$iLastTab Then
						_showTab($arTabs,$iTab)
						$iLastTab=$iTab
					ElseIf $iTab<>$iLastTab Then
						$iLastTab=-1
					EndIf
			EndSwitch
		Case GUICtrlGetHandle($hListViewPacket)
            Switch $iCode
				Case $NM_CLICK
					$tInfo = DllStructCreate($tagNMITEMACTIVATE, $ilParam)
					If DllStructGetData($tInfo, "Index")<>-1 Then _showPacketFunctions(_GUICtrlListView_GetItemText($hListViewPacket,DllStructGetData($tInfo, "Index"),0), _
																					   _GUICtrlListView_GetItemText($hListViewPacket,DllStructGetData($tInfo, "Index"),1))
            EndSwitch
		Case GUICtrlGetHandle($hListViewFunction)
            Switch $iCode
				Case $NM_DBLCLK
					$tInfo = DllStructCreate($tagNMITEMACTIVATE, $ilParam)
					If DllStructGetData($tInfo, "Index")<>-1 Then
						_switchGui($iGUIEDITGUI)
						_loadFunction($arFunctionList,DllStructGetData($tInfo, "Index"))
					EndIf
            EndSwitch
    EndSwitch
    Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_NOTIFY